/*
 * Copyright (C) 2008 Julien VAUBOURG
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

import java.util.ArrayList;

public class Arene {
	public Case[][] arene;
	public ArrayList<Coordonnees> robots;
	public int incrementRobot;
	public AreneGraphique ax;

	// Constructeur
	public Arene(int W, int H){
		this.arene = new Case[H][W];
		this.robots = new ArrayList<Coordonnees>();
		this.incrementRobot = 0;
		this.initialiser();
	}

	// Ajout d'une case (ou mise à jour en écrasant)
	void ajouteCase(Case c , int x ,int y){
		this.arene[y][x] = c;
	}

	// Initialisation de l'aréne
	public void initialiser() {
		for(int y=0; y < arene.length ; y++) {
			for(int x=0; x < arene[y].length; x++) {
				// Le tour de l'aréne est un mur
				if(y == 0 || y == arene.length-1 || x == 0 || x == arene[y].length-1)
					new Mur(x, y, this);
				else {
					double nombre = Math.random() * 100;
					
					// 5% de murs dans l'aréne
					if (nombre <= 5.0)
						new Mur(x, y, this);
					else
						new CaseVide(x, y, this);			
				}
			}
		}
	}	
	
	// Affichage de l'aréne
	public String toString() {
		String retour = "";
		
		for(int i = 0; i < this.arene.length; i++) {
			for(int j = 0; j < this.arene[i].length; j++)
				retour += this.arene[i][j];
			
			retour += "\n";
		}
		
		return retour;
	}
}
