/*
 * Copyright (C) 2008 Julien VAUBOURG
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

import java.awt.*;
import javax.swing.*;

class AreneGraphique {
	public Arene a;
    public JFrame fenetre;
    public JLabel affichage;
    public Container conteneur;
    public final String URL_IMG = "/home/infoetu/vaubourj/perso/S2/workspace/ROBOTS/";
    public Color[] couleurs = {
    			Color.RED,
    			Color.BLUE,
    			Color.GREEN,
    			Color.CYAN,
    			Color.MAGENTA,
    			Color.ORANGE,
    			Color.LIGHT_GRAY,
    			Color.WHITE
    	};
    public String[] couleursFr = {
			"rouge  ",
			"bleu   ",
			"vert   ",
			"cyan   ",
			"magenta",
			"orange ",
			"gris   ",
			"blanc  "
		};

    // Constructeur
    public AreneGraphique(Arene a) {
    	this.a = a;
    	
		this.fenetre = new JFrame("Arene");
		this.fenetre.setSize(200, 200);

		this.conteneur = new JPanel();
		GridLayout disposition = new GridLayout(a.arene.length, a.arene[0].length);		  
		this.conteneur.setLayout(disposition);
		conteneur.setBackground(new Color(238, 238, 238));
		
		this.fenetre.getContentPane().add(conteneur);
		this.rafraichir();
    }

    // Rafraichissement de l'aréne (actualisation des cases non-murées)
	public void rafraichir() {
		for(int i = 0; i < a.arene.length; i++) {
			for(int j = 0; j < a.arene[i].length; j++) {
				if(a.arene[i][j] instanceof Mur) {
					if(!this.fenetre.isVisible()) {
						this.affichage = new JLabel(new ImageIcon(URL_IMG + "mur.jpg"));
						conteneur.add(this.affichage);
					}
				} else {
					if(!this.fenetre.isVisible()) {
						if(a.arene[i][j] instanceof Robot) {
							this.affichage = new JLabel(new ImageIcon(URL_IMG + "robot.png"));
							this.affichage.setOpaque(true);
							this.affichage.setBackground(this.couleurs[((Robot) a.arene[i][j]).numero - 1]);
						} else if(a.arene[i][j] instanceof Mine) {
							this.affichage = new JLabel(new ImageIcon(URL_IMG + "mine.png"));
							this.affichage.setOpaque(true);
							this.affichage.setBackground(this.couleurs[((Mine) a.arene[i][j]).proprietaire.numero - 1]);
						} else {
							this.affichage = new JLabel();
							this.affichage.setText(a.arene[i][j].toString());							
						}
						
						conteneur.add(this.affichage);
					} else {
						JLabel caseActuelle = (JLabel) conteneur.getComponent((i * a.arene[i].length) + j);
						
						if(a.arene[i][j] instanceof Robot) {
							caseActuelle.setText("");
							caseActuelle.setIcon(new ImageIcon(URL_IMG + "robot.png"));
							caseActuelle.setOpaque(true);
							caseActuelle.setBackground(this.couleurs[((Robot) a.arene[i][j]).numero - 1]);							
						} else if(a.arene[i][j] instanceof Mine) {
							caseActuelle.setText("");
							caseActuelle.setIcon(new ImageIcon(URL_IMG + "mine.png"));
							caseActuelle.setOpaque(true);
							caseActuelle.setBackground(this.couleurs[((Mine) a.arene[i][j]).proprietaire.numero - 1]);
						} else {
							caseActuelle.setOpaque(false);
							caseActuelle.setIcon(null);
							caseActuelle.setBackground(null);
							caseActuelle.setText(a.arene[i][j].toString());							
						}
					}
				}
			}
		}
		
		this.fenetre.pack();
		this.fenetre.setVisible(true);
	}
}
