/*
 * Copyright (C) 2008 Julien VAUBOURG
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

abstract public class Case {
	Coordonnees coordonnees;
	Arene a;

	public Case(int x, int y, Arene a) {
		this.coordonnees = new Coordonnees(x, y);
		this.a = a;
		this.a.ajouteCase(this, x, y);
	}

	abstract boolean deplacementPossible();
	
	// Si un robot se déplace sur la case courante
	public void deplace(Robot r) throws MouvementException {
		if(this.deplacementPossible()) {
			// Si le robot était sur une de ses mines, elle réapparait
			if(r.estSurUneMinePerso)
				new Mine(r, r.coordonnees.getX(), r.coordonnees.getY());
			else // Sinon une case vide
				new CaseVide(r.coordonnees.getX(), r.coordonnees.getY(), this.a);
			
			// Suppression du robot dans la liste de coor
			this.a.robots.remove(this.a.robots.indexOf(r.coordonnees));
			
			// Mise à jour des coor du robot
			r.coordonnees.setX(this.coordonnees.getX());
			r.coordonnees.setY(this.coordonnees.getY());
			
			// Placement du robot dans l'aréne
			this.a.arene[this.coordonnees.getY()][this.coordonnees.getX()] = r;
	
			// Ajout des nouvelles coor dans la liste
			this.a.robots.add(r.coordonnees);
			
			// Cas particulier : case mine
			if(this instanceof Mine) {
				// Perte de points si un robot arrive sur une mine étrangère
				if(((Mine) this).proprietaire != r) {
					r.energie.victimeMine();
					r.cerveau.reagit(); // Mouvement en reaction
				} else // Sinon on indique qu'il est sur une de ses mines
					r.estSurUneMinePerso = true;
			} else
				r.estSurUneMinePerso = false;
		} else {
			if(this instanceof Mur)
				throw new MouvementException("mur");
			else if(this instanceof Mur)
				throw new MouvementException("robot");
		}
	}
	
	abstract boolean bloqueTir();

/*	public ArrayList getCoordonnees() {
		ArrayList<Integer> retour = new ArrayList<Integer>();
		retour.add(this.coordonnees.getX());
		retour.add(this.coordonnees.getY());

		return retour;
	} */
}
