/*
 * Copyright (C) 2008 Julien VAUBOURG
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

public class CerveauGaetan extends Cerveau {
		public CerveauGaetan() {}
		
		public void getMouvement() {
			int aleatoire = (int) (Math.random() * 10);
			boolean mouvement = true;

			if(aleatoire > 8) {
				if(r.coordonnees.getX() < 3) // Près du mur gauche
					r.test(1, r.tir("droite", false), r.deplacement("droite", false));
				else if(r.coordonnees.getY() < 3) // Près du mur haut
					r.test(1, r.tir("bas", false), r.deplacement("bas", false));
				else if(r.a.arene[0].length - r.coordonnees.getX() < 3) // Près du mur droit
					r.test(1, r.tir("gauche", false), r.deplacement("gauche", false));
				else if(r.a.arene.length - r.coordonnees.getY() < 3) // Près du mur bas
					r.test(1, r.tir("haut", false), r.deplacement("haut", false));
				else
					mouvement = false;
			}
			
			// Aucun mouvement lié aux bords de l'aréne effectué
			if(mouvement) {
				switch(aleatoire) {
					case 0 :
						r.test(3, r.deplacement("haut", false), r.poseMine("droite", false));
					break;
					
					case 1 :
						r.test(1, r.fuite(false), r.poursuite(false));
					break;
					
					case 2 :
						if(r.energie.quota > 1400)
							r.poseMine("haut", true);
						else
							r.poseMine("bas", true);
					break;
					
					case 3 :
						r.test(4, r.poseMine("gauche", false), r.tir("gauche", false));
					break;
					
					case 4 :
						r.tir("droite", true);
					break;
					
					case 5 :
						r.poursuite(true);
					break;
					
					case 6 :
						if(r.energie.quota > 1000)
							r.tir("haut", true);
						else
							r.fuite(true);
					break;
					
					case 7 :
						r.tir("droite", true);
					break;
					
					case 8 :
						r.deplacement("bas", true);
					break;
					
					case 9 :
						r.poseMine("bas", true);
					break;
					
					case 10 :
						r.deplacement("gauche", true);
					break;
		
					default :
						r.poursuite(true);					
				}
			}
		}

		// Que fait le robot si il passe sur une mine ?
		public void reagit() {
			r.poursuite(true);
		}
}
