/*
 * Copyright (C) 2008 Julien VAUBOURG
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

public class Deplacement extends Mouvement {
	String direction;
	
	public Deplacement(Robot r, String direction) {
		super(r);
		this.direction=direction;
	}

	public void effectueMouvement(){
		int xsuivant = this.r.coordonnees.getX();
		int ysuivant = this.r.coordonnees.getY();
				
		if(this.direction == "haut")
			ysuivant--;
		else if(this.direction == "bas")
			ysuivant++;
		else if(this.direction == "gauche")
			xsuivant--;
		else if(this.direction == "droite")
			xsuivant++;

		try { // Déplacement du robot
			a.arene[ysuivant][xsuivant].deplace(r);
			r.energie.deplacement(); // Perte énergie
		} catch(MouvementException e) {
			System.out.println(" ! " + e.getMessage());
		}
	}
}
