import java.util.ArrayList;

public class Energie {
	private final int INITQUOTA = 50;
	Robot r;
	int quota;
	
	// Constructeur
	public Energie(Robot r) {
		this.quota = INITQUOTA;
		this.r = r;
	}
	
	// Le robot est-il mort ?
	public boolean mort() {
		if(this.quota <= 0) {
			System.out.println(" + " + r.numero + " est mort");
			
			// Ecrasement du robot dans l'aréne
			new CaseVide(r.coordonnees.getX(), r.coordonnees.getY(), r.a);
			
			// Suppression des coordonnées dans la liste
			r.a.robots.remove(r.a.robots.indexOf(r.coordonnees));
			
			return true;
		}
		
		return false;
	}

	// Le jeu est-il terminé ?
	public static boolean gagnant(ArrayList<Robot> joueurs) {
		if(joueurs.size() == 1) {
			System.out.println(" + And the winner is : the " + joueurs.get(0) + " robot");
			return true;
		} else if(joueurs.size() == 0) {
			System.out.println(" + Mort générale..." + joueurs.get(0));
			return true;
		} else
			return false;
	}

	
	/* Perte des points selon le type d'événement */
	
	public void deplacement() {
		this.quota -= 5;
	}
	
	public void fuite() {
		this.quota -= 4;
	}
	
	public void poursuite() {
		this.quota -= 4;
	}
	
	public void tir() {
		this.quota -= 3;
	}
	
	public void poseMine() {
		this.quota -= 10;
	}
	
	public void victimeTir() {
		this.quota -= 20;
	}
	
	public void victimeMine() {
		this.quota -= 200;
	}
	
	public void test() {
		this.quota -= 4;
	}
	
	// Affichage
	public String toString() {
		String retour = "(r" + r.numero + ") [";
		int nbBarres = this.quota / 100;
		int nbBarresMax = INITQUOTA / 100;
		int pourcentage = (this.quota * 100) / INITQUOTA;
		int iMemoire = 0;

		for(int i=0; i < nbBarres; i++) {
			retour += "|";
			iMemoire = i;
		}
		
		for(int i=0; i < (nbBarresMax - iMemoire - 1); i++)
			retour += " ";

		return retour + "] " + pourcentage + "%" + (pourcentage < 100 ? " " : "") + " (" + this.quota + "pts)"; 
	}
}