import java.awt.*;

public class Robot extends Case {
	int numero;
	Energie energie;
	Robot robotLePlusProche;
	boolean estSurUneMinePerso;
	Cerveau cerveau;
	
	// Constructeur
	public Robot(Cerveau c, int x, int y, Arene a) {
		super(x, y, a);
		this.cerveau = c;
		this.cerveau.r = this;
		this.a.robots.add(this.coordonnees);

		// Création du nouveau robot
		this.numero = ++this.a.incrementRobot;
		this.energie = new Energie(this);
		this.estSurUneMinePerso = false;
	}
	
	public boolean bloqueTir() {
		return true;
	}

	public boolean deplacementPossible() {
		return false;
	}

	// Calcul du robot le plus proche de celui-ci
	public Robot lePlusProche() {
		Test t = new Test(this);
		return t.lePlusProche();
	}
	
	/* Encapsulation des Mouvement */
	
	public Deplacement deplacement(String direction, boolean execute) {
		Deplacement d = new Deplacement(this, direction);
		
		if(execute)
			d.effectueMouvement();
		
		return d;
	}
	
	public Fuite fuite(boolean execute) {
		Fuite f = new Fuite(this);
		
		if(execute)
			f.effectueMouvement();
		
		return f;
	}
	
	public Poursuite poursuite(boolean execute) {
		Poursuite p = new Poursuite(this);
		
		if(execute)
			p.effectueMouvement();
		
		return p;
	}
	
	public void test(int seuil, Mouvement m1, Mouvement m2) {
		Test t = new Test(this, seuil, m1, m2);
		t.effectueMouvement();
	}
	
	public PoseMine poseMine(String direction, boolean execute) {
		PoseMine m = new PoseMine(this, direction);
		
		if(execute)
			m.effectueMouvement();
		
		return m;
	}
	
	public Tir tir(String direction, boolean execute) {
		if(direction == "droite" || direction == "gauche") {
			TirHorizontal t = new TirHorizontal(this, direction);
			
			if(execute)
				t.effectueMouvement();
			
			return t;
		}
		
		TirVertical t = new TirVertical(this, direction);
			
		if(execute)
			t.effectueMouvement();
			
		return t;
	}
	
	// Indication graphique pour le robot qui se fait tirer dessus
	public void tirVisuel() {
		Color ancien = this.a.ax.conteneur.getComponent((this.coordonnees.getY() * a.arene[this.coordonnees.getY()].length) + this.coordonnees.getX()).getBackground();
		
		this.a.ax.conteneur.getComponent((this.coordonnees.getY() * a.arene[this.coordonnees.getY()].length) + this.coordonnees.getX()).setBackground(Color.BLACK);
		
		try { Thread.sleep(100); }
		catch (InterruptedException e) { e.printStackTrace(); }

		this.a.ax.conteneur.getComponent((this.coordonnees.getY() * a.arene[this.coordonnees.getY()].length) + this.coordonnees.getX()).setBackground(ancien);
		
		try { Thread.sleep(100); }
		catch (InterruptedException e) { e.printStackTrace(); }
		
		this.a.ax.conteneur.getComponent((this.coordonnees.getY() * a.arene[this.coordonnees.getY()].length) + this.coordonnees.getX()).setBackground(Color.YELLOW);
		
		try { Thread.sleep(100); }
		catch (InterruptedException e) { e.printStackTrace(); }

		this.a.ax.conteneur.getComponent((this.coordonnees.getY() * a.arene[this.coordonnees.getY()].length) + this.coordonnees.getX()).setBackground(ancien);
	}

	// Affichage
	public String toString() {
		return "" + this.numero;
	}
}